// fourVid.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <qedit.h>
#include <DShow.h>
#include <atlbase.h>
#include <Windows.h>

#pragma comment(lib,"Strmiids.lib")

using namespace std;



bool bOFlag;
bool bNFlag;
bool bAFlag;
bool bBFlag;



#define safeReleases \
	SafeRelease(&pGraph); \
	SafeRelease(&pControl); \
	SafeRelease(&pEvent); \
	SafeRelease(&pGrabberBaseFilter); \
	SafeRelease(&pSampleGrabber); 

template <class T> void SafeRelease(T **ppT)
{
    if (*ppT)
    {
        (*ppT)->Release();
        *ppT = NULL;
    }
}


void FindCutoff(int &nCutoff, int nToStop, int* anColors)
{
	int nInByte = 0;
	for (int iii = 0; iii < nToStop; iii++)
	{
		if (nInByte != anColors[nCutoff])
			nInByte++;
		else
		{
			nInByte = 0;
			nCutoff++;
		}
	}
}

double* PixelLoc(int nX, int nY, double adPicture[96*64], double &dGarbage)
{
	if (nX < 0 || nX >= 96 || nY < 0 || nY >=64)
		return &dGarbage;
	return &adPicture[nY*96 + nX];
}

void ClipPixel(double * dPos)
{
	if (*dPos > 255)
		*dPos = 255;
	if (*dPos < 0)
		*dPos = 0;
	return;
}

int MakeFileName(char achFinal[MAX_PATH], char * achInit)
{
	int nPathLength = 0;
	for (int iii = 0; achInit[iii]; iii++)
	{
		achFinal[nPathLength] = achInit[iii];
		if (achFinal[nPathLength] == 0x5C)
		{
			nPathLength++;
			achFinal[nPathLength] = 0x5C;
		}
		nPathLength++;
	}
	return nPathLength;
}

class CSampleGrabberCB: public ISampleGrabberCB
{
public:
	ISampleGrabber *pSampleGrabber;
	unsigned char *achOutBuf;
	int nFrames;
	int nFrameCount;
	double adDitherFilter[96*64];
	bool bOrderedD;
	bool bFSDither;
	bool bAbsolute;

	CSampleGrabberCB(void)
	{
		achOutBuf = NULL;
		nFrames = 0;
		nFrameCount = 2;
		pSampleGrabber = NULL;
		bOrderedD = false;
		bFSDither = true;
		bAbsolute = false;

		int anDitherA[10] = {7, 5, -7, -3, -1, 10, 4, -8, -4, 2};
		int anDitherB[10] = {-9, -5, 1, 8, 6, -6, -2, 0, 9, 3};
		int anDitherStarts[5] = {0, 4, 8, 2, 6};
		for (int nRow = 0; nRow < 64; nRow++)
		{
			for (int nColumn = 0; nColumn < 96; nColumn++)
				adDitherFilter[nRow*96 + nColumn] = anDitherA[(anDitherStarts[(nRow/2)%5] + nColumn) % 10];
			nRow++;
			for (int nColumn = 0; nColumn < 96; nColumn++)
				adDitherFilter[nRow*96 + nColumn] = anDitherB[(anDitherStarts[(nRow/2)%5] + nColumn) % 10];

		}

	}

	STDMETHOD(QueryInterface)(REFIID InterfaceIdentifier, VOID** ppvObject)
	{
		if (InterfaceIdentifier == __uuidof(ISampleGrabberCB))
		{
			*ppvObject = (ISampleGrabberCB**) this;
			return S_OK;
		}
		return E_NOINTERFACE;
	}
	STDMETHOD_(ULONG, AddRef)()
	{
		return 2;
	}
	STDMETHOD_(ULONG, Release)()
	{
		return 1;
	}
	STDMETHODIMP SampleCB(double dTime, IMediaSample *pms)
	{
		return 0;
	}

	STDMETHODIMP BufferCB(double dSampleTime, byte *pBuffer, long nBufSize)
	{
		nFrameCount++;
		if (nFrameCount != 3)
			return 0;
		nFrameCount = 0;
		AM_MEDIA_TYPE MediaType;
		ZeroMemory(&MediaType, sizeof(MediaType));
		HRESULT hr = pSampleGrabber->GetConnectedMediaType(&MediaType);
		if (FAILED(hr))
		{
			cout << "Can't get media type" << endl;
			return hr;
		}
		VIDEOINFOHEADER *pVideoHeader = (VIDEOINFOHEADER*)MediaType.pbFormat;
		if (pVideoHeader == NULL)
		{
			cout << "pVideoHeader = NULL" << endl;
			return hr;
		}
		
		BITMAPINFO BitmapInfo;
		ZeroMemory(&BitmapInfo, sizeof(BitmapInfo));
		CopyMemory(&BitmapInfo.bmiHeader, &(pVideoHeader->bmiHeader), sizeof(BITMAPINFOHEADER));

		if (BitmapInfo.bmiHeader.biHeight != 128)
		{
			cout << "Error, height not 128" << endl;
			exit(1);
		}
		if (BitmapInfo.bmiHeader.biWidth != 192)
		{
			cout << "Error, width not 192" << endl;
			exit(1);
		}


		double adFrameBrightness[96*64] = {0};
		int anBrightnessCount[256] = {0};

		for (int nRow = 0; nRow < 64; nRow++)
		{
			for (int nColumn = 0; nColumn < 96; nColumn++)
			{
				int nOrigin = (63-nRow)*192*3*2 + nColumn*3*2;
				double dThisBrightness = (double)(
					(unsigned char)pBuffer[nOrigin] * 2126 +
					(unsigned char)pBuffer[nOrigin + 1] * 7152 + 
					(unsigned char)pBuffer[nOrigin + 2] * 0722 +
					(unsigned char)pBuffer[nOrigin + 3] * 2126 +
					(unsigned char)pBuffer[nOrigin + 4] * 7152 +
					(unsigned char)pBuffer[nOrigin + 5] * 0722 +
					(unsigned char)pBuffer[nOrigin + 192*3] * 2126 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 1] * 7152 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 2] * 0722 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 3] * 2126 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 4] * 7152 +
					(unsigned char)pBuffer[nOrigin + 192*3 + 5] * 0722) / 40000;

				adFrameBrightness[nRow*96 + nColumn] = dThisBrightness;
				anBrightnessCount[(int)floor(dThisBrightness)]++;
			}
		}

		int nPixelsCounted = 96*64;
		for (int iii = 0; iii < 256; iii++)
		{
			if (anBrightnessCount[iii] > 96*64/10)			//this implies a boarder
			{
				nPixelsCounted-= anBrightnessCount[iii];
				anBrightnessCount[iii] = 0;
			}
		}

		int nLowCutoff = 0x00;
		int nMidCutoff = 0x00;
		int nHighCutoff = 0x00;
		FindCutoff(nLowCutoff, nPixelsCounted/4, anBrightnessCount);
		FindCutoff(nMidCutoff, nPixelsCounted/2, anBrightnessCount);
		FindCutoff(nHighCutoff, nPixelsCounted*3/4, anBrightnessCount);

		if (bAbsolute)
		{
			nLowCutoff = 0x40;
			nMidCutoff = 0x80;
			nHighCutoff = 0xC0;
		}


		unsigned char achColors[4] = {nLowCutoff / 2, (nMidCutoff + nLowCutoff) / 2, (nMidCutoff + nHighCutoff) / 2, (nHighCutoff+255) / 2};

		double dFilterStrength = (nHighCutoff - nLowCutoff)/4/10   /2 ; //half of the average of the spaces /10 because filter is 10 based

		double dGarbage = 0;
		bool bReverse = false;

		for (int nRow = 0; nRow < 64; nRow++)
		{
			for (int nColumn = (bReverse ? 95 : 0); (bReverse ? nColumn >= 0 : nColumn < 96); (bReverse ? nColumn-- : nColumn++))
			{
				int nPutLoc = nRow*96 + nColumn;
				double dThisActual = *PixelLoc(nColumn, nRow, adFrameBrightness, dGarbage) + bOrderedD*(adDitherFilter[nPutLoc]*dFilterStrength);

				int nThisNew = 3;
				if (dThisActual > nMidCutoff)
					nThisNew-= 2;
				if ((dThisActual > nHighCutoff) || ((dThisActual > nLowCutoff) && (dThisActual <= nMidCutoff)))
					nThisNew--;

				if (bReverse)
				{
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2]/2 + nThisNew/2*128;
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1]/2 + (nThisNew & 1)*128;
				}
				else
				{
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2]*2 + nThisNew/2;
					achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1] = achOutBuf[nFrames*768*2 + (nPutLoc/8)*2 + 1]*2 + (nThisNew & 1);
				}

				if (bFSDither)
				{
					double *dPos;
					double dQuantError = (dThisActual - achColors[3-nThisNew])/16;

					dPos = PixelLoc(nColumn + (bReverse ? -1 : 1) , nRow, adFrameBrightness, dGarbage);
					*dPos += dQuantError*7;
					ClipPixel(dPos);

					dPos = PixelLoc(nColumn - 1, nRow+1, adFrameBrightness, dGarbage);
					*dPos += dQuantError * (bReverse ? 1 : 3);
					ClipPixel(dPos);

					dPos = PixelLoc(nColumn, nRow+1, adFrameBrightness, dGarbage);
					*dPos += dQuantError*5;
					ClipPixel(dPos);

					dPos = PixelLoc(nColumn + 1, nRow+1, adFrameBrightness, dGarbage);
					*dPos += dQuantError * (bReverse ? 3 : 1);
					ClipPixel(dPos);
				}
				nPutLoc++;
			}
			bReverse^= 1;
		}




		nFrames++;
		if (dSampleTime == floor(dSampleTime))
			cout << dSampleTime << " ";
		return 0;
	}
};

int ConvertVid(char achVidPath[MAX_PATH], unsigned char * achVideoBuf, int &nFrames)
{
	IGraphBuilder *pGraph = NULL;
	IMediaControl *pControl = NULL;
	IMediaEvent *pEvent = NULL;
	IBaseFilter *pGrabberBaseFilter = NULL;
	ISampleGrabber *pSampleGrabber = NULL;


	HRESULT hr = CoInitialize(NULL);
	if (FAILED(hr))
	{
		printf("ERROR - Could not initialize COM library");
		safeReleases; 
		return 0;
	}

	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						IID_IGraphBuilder, (void **)&pGraph);
	if (FAILED(hr))
	{
		printf("ERROR - Could not create the Filter Graph Manager.");
		safeReleases; 
		return 0;
	}

	AM_MEDIA_TYPE mt;
	hr = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, 
						IID_IBaseFilter, (void **)&pGrabberBaseFilter);
	if (FAILED(hr))
	{
		safeReleases; 
		return 0;
	}

	pGrabberBaseFilter->QueryInterface(IID_ISampleGrabber, (void**)&pSampleGrabber);
	if (pSampleGrabber == NULL)
	{
		safeReleases; 
		return 0;
	}

	hr = pGraph->AddFilter(pGrabberBaseFilter,L"Grabber");
	if (FAILED(hr))
	{
		safeReleases; 
		return 0;
	}

	ZeroMemory(&mt, sizeof(AM_MEDIA_TYPE));
	mt.majortype = MEDIATYPE_Video;
	mt.subtype = MEDIASUBTYPE_RGB24;
	mt.formattype = FORMAT_VideoInfo;
	hr = pSampleGrabber->SetMediaType(&mt);
	if (FAILED(hr))
	{
		safeReleases; 
		return 0;
	}

	hr = pGraph->QueryInterface(IID_IMediaControl, (void **)&pControl);
	hr = pGraph->QueryInterface(IID_IMediaEvent, (void **)&pEvent);

	LPWSTR lFileName = SysAllocStringLen(NULL, MAX_PATH);
	MultiByteToWideChar(CP_ACP, 0, achVidPath, -1, lFileName, MAX_PATH);
	hr = pGraph->RenderFile(lFileName, NULL);
	SysFreeString(lFileName);
	if (FAILED(hr))
	{
		cout << "Video file probably not found" << endl;
		safeReleases;
		return 0;
	}

	CSampleGrabberCB CB;
	CB.pSampleGrabber = pSampleGrabber;
	hr = pSampleGrabber->SetCallback(&CB, 1);
	CB.achOutBuf = achVideoBuf;

	if (bAFlag)
		CB.bAbsolute = true;
	if (bBFlag)
		CB.bOrderedD = true;
	if (bNFlag)
		CB.bFSDither = false;
	if (bOFlag)
	{
		CB.bFSDither = false;
		CB.bOrderedD = true;
	}

	CComQIPtr<IMediaSeeking> pSeek = pControl;
	LONGLONG nDuration;
	hr = pSeek->GetDuration(&nDuration);
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	REFERENCE_TIME rtStart = 0;
	REFERENCE_TIME rtStop = nDuration-1;

	hr = pSeek->SetPositions(&rtStart, AM_SEEKING_AbsolutePositioning,
		&rtStop, AM_SEEKING_AbsolutePositioning);

	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	hr = pSeek->SetRate(1.00);		//I would love to set this to something faster
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	CComQIPtr<IVideoWindow> pVideoWindow = pGraph;
	hr = pVideoWindow->put_AutoShow(OAFALSE);

	CComQIPtr<IBasicAudio> pBasicAudio = pGraph;
	hr = pBasicAudio->put_Volume(-10000);		// -10,000 is silence

	hr = pControl->Run();
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}

	    long evCode;
    hr = pEvent->WaitForCompletion(INFINITE, &evCode);
	if (FAILED(hr))
	{
		safeReleases;
		return 0;
	}
	cout << endl;
	nFrames = CB.nFrames;
	return CB.nFrames*768*2;
}






int nPutPtr = 0;
int nPutByte = 0;

class CompData
{
public:
	int nValue;
	int nBits;
	CompData(int nValu, int nBit)
	{
		nValue = nValu;
		nBits = nBit;
	}
};


void AlignByte(unsigned char* achBuffer)
{
	if (nPutByte)
	{
		for (int iii = nPutByte; iii < 8; iii++)
			achBuffer[nPutPtr]*=2;
		nPutPtr++;
		nPutByte = 0;
	}
}

CompData HuffmanTranslate(int nInput)
{
	if (nInput <= 143)
		return CompData(nInput + 0x30, 8);
	if (nInput <= 255)
		return CompData(nInput + 0x190-144, 9);
	if (nInput <= 279)
		return CompData(nInput - 256, 7);
	return CompData(nInput + 0xC0 - 280, 8);
}

/*
0-143 		00110000 - 10111111
144-255	       	110010000- 111111111 
256-279		0000000  - 0010111
280-287		11000000 - 11000111
*/

CompData HuffmanDistance(int nDist)
{
	int anUpperLen[30] = {1, 2, 3, 4, 6, 8, 12, 16, 24, 32,
		48, 64, 96, 128, 192, 256, 384, 512, 768, 1024,
		1536, 2048, 3072, 4096, 6144, 8192, 12288, 24576, 32768};
	int anBits[30] = {0, 0, 0, 0, 1, 1, 2, 2, 3, 3,
		4, 4, 5, 5, 6, 6, 7, 7, 8, 8,
		9, 9, 10, 10, 11, 11, 12, 12, 13, 13};
	for (int iii = 0; ; iii++)
		if (nDist <= anUpperLen[iii])
		{
			if (!anBits[iii])
				return CompData(iii, 5);
			return CompData((iii << anBits[iii]) + nDist-anUpperLen[iii-1]-1, 5 + anBits[iii]);
		}
}

CompData HuffmanLength(int nLen)
{
	int anUpperLen[29] = {3, 4, 5, 6, 7, 8, 9, 10, 12, 14,
		16, 18, 22, 26, 30, 34, 42, 50, 58, 66,
		82, 98, 114, 130, 162, 194, 226, 257, 258};
	int anBits[29] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
		1, 1, 2, 2, 2, 2, 3, 3, 3, 3,
		4, 4, 4, 4, 5, 5, 5, 5, 0};
	for (int iii = 0; ; iii++)
		if (nLen <= anUpperLen[iii])
		{
			if (!anBits[iii])
				return HuffmanTranslate(iii + 257);  
			return CompData((HuffmanTranslate(iii + 257).nValue << anBits[iii]) + nLen - anUpperLen[iii-1] - 1, HuffmanTranslate(iii + 257).nBits + anBits[iii]);
		}
}

void PutCompData(CompData sCompData, unsigned char* achBuffer)
{
	int nReverse = 0;
	for (int iii = 0; iii < sCompData.nBits; iii++)
	{
		nReverse = nReverse*2 + (sCompData.nValue % 2);
		sCompData.nValue/= 2;
	}
	for (int iii = 0; iii < sCompData.nBits; iii++)
	{
		achBuffer[nPutPtr] = achBuffer[nPutPtr] * 2 + (nReverse % 2);
		nReverse/= 2;
		nPutByte++;
		if (nPutByte == 8)
		{
			nPutByte = 0;
			nPutPtr++;
		}
	} 
}

void PutUncompData(int nLength, int nPtr, unsigned char* achSource, unsigned char* achDest)
{
	AlignByte(achDest);
	for (int iii = 0; iii < nLength; iii ++, nPutPtr ++)
		achDest[nPutPtr] = achSource[nPtr + iii];
}




int main(int argc, char* argv[])
{
	int	nIndv = 1;
	int nCompress = 1;
	int nDeflate = 1;






	cout << endl;
	cout << "===================== FourVid =============================" << endl;
	cout << "By: Brian Coventry" << endl;

	bOFlag = false;
	bNFlag = false;
	bAFlag = false;
	bBFlag = false;
	int nActualArgs = argc;

	for (int iii = 1; iii < argc; iii++)
	{
		if (argv[iii][0] == '-')
		{
			switch (argv[iii][1])
			{
			case 'O':
				bOFlag = true;
				break;
			case 'o':
				bOFlag = true;
				break;
			case 'N':
				bNFlag = true;
				break;
			case 'n':
				bNFlag = true;
				break;
			case 'A':
				bAFlag = true;
				break;
			case 'a':
				bAFlag = true;
				break;
			case 'B':
				bBFlag = true;
				break;
			case 'b':
				bBFlag = true;
				break;
			}
			nActualArgs--;
		}
	}

	int nArgStart = argc-nActualArgs;


	if (nActualArgs != 3)
	{
		cout << "Proper command syntax is: fourVid [flags] video.wmv output.bin" << endl;
		cout << "Flags:" << endl;
		cout << " -A - use absolute brightness cutoffs (relative is default)" << endl;
		cout << " -B - use both dithering styles (not really a good idea)" << endl;
		cout << " -N - don't use any dithering (Floyd - Steinburg dither is default)" << endl;
		cout << " -O - use ordered dithering (Floyd - Steinburg dither is default)" << endl;
		exit(1);
	}
	

	char achVidPath[MAX_PATH] = {0};
	MakeFileName(achVidPath, argv[nArgStart + 1]);

	char achFinalPath[MAX_PATH] = {0};
	MakeFileName(achFinalPath, argv[nArgStart + 2]);


	unsigned char * achPlayCode = NULL;
	int nPlayCodeSize = 0;
	char achName[13] = "playCode.bin";
	ifstream fPlayCode (achName, ios::_Nocreate | ios::binary | ios:: ate | ios:: out);
	if (!fPlayCode)
	{
		cerr << "playCode.bin not found" << endl;
		delete[] achPlayCode;
		exit(1);
	}
	nPlayCodeSize = (int)fPlayCode.tellg();
	achPlayCode = new unsigned char [nPlayCodeSize];
	fPlayCode.seekg(0, ios::beg);
	fPlayCode.read((char*)achPlayCode, nPlayCodeSize);
	fPlayCode.close();




	unsigned char * achFinal = new unsigned char [10000000];
	int nFrames = 0;
	int nVidSize = ConvertVid(achVidPath, achFinal, nFrames);
	if (!nVidSize)
	{
		cout << "Error in video conversion" << endl;
		delete[] achFinal;
		delete[] achPlayCode;
		exit(1);
	}

	int nFiles = nVidSize/768/2;




	
	unsigned char* achSave = new unsigned char [768*2*nFiles + 100000];
	int nGetPtr = 0;
	nPutPtr = 0;
	for (int iii = 0; iii < 768*2*nFiles; iii++)
		achSave[iii] = 0;
	if (!nDeflate)
	{
		for (int nThisFile = 0; nThisFile < nFiles; nThisFile++)
		{
			while (nGetPtr < 768*2*(nThisFile+1))
			{
				int nTempPtr = nGetPtr;
				if ((!achFinal[nGetPtr] || achFinal[nGetPtr] == 255) && nCompress)
				{
					while ((achFinal[nGetPtr] == achFinal[nTempPtr]) && (nTempPtr < 768*2*(nThisFile+1)) && (nTempPtr-nGetPtr < 255))
						nTempPtr++;
					if (nTempPtr - nGetPtr >= 2)
					{
						achSave[nPutPtr] = achFinal[nGetPtr];
						nPutPtr++;
						achSave[nPutPtr] = achFinal[nGetPtr];
						nPutPtr++;
					achSave[nPutPtr] = nTempPtr-nGetPtr-1; //-1 is for easier z80
						nPutPtr++;
						nGetPtr = nTempPtr;
					}
					else 
					{
						achSave[nPutPtr] = achFinal[nGetPtr];	
						nPutPtr++;
						nGetPtr++;
					}
				}
				else
				{
					achSave[nPutPtr] = achFinal[nGetPtr];
					nPutPtr++;
					nGetPtr++;
				}
			}
		}
	}
	else 
	{
		int nUncompBytes = 0;
		int nUncompStart = 0;
		bool bComp = false;
		while (nGetPtr < nFiles*768*2)
		{
			int nMatchFinder = nGetPtr - 1;
			int nMatchLength = 0;
			int nLongestMatch = 0;
			int nLongestAddr = 0;
			while (nGetPtr - nMatchFinder < 768*2*2 - 1 && nMatchFinder >= 0)
			{
				nMatchLength = 0;
				while (achFinal[nGetPtr + nMatchLength] == achFinal[nMatchFinder + nMatchLength] && nGetPtr + nMatchLength < nFiles*768*2 && nMatchLength < 257)
					nMatchLength++;
				if (nMatchLength > nLongestMatch)
				{
					nLongestMatch = nMatchLength;
					nLongestAddr = nMatchFinder;
				}
				nMatchFinder--;
			}
			
			if (nLongestMatch < 3)
			{
				if (!nUncompBytes)
					nUncompStart = nGetPtr;
				nUncompBytes++;
				if (nUncompBytes >= 255)
				{
					if (bComp)
						PutCompData(HuffmanTranslate(256), achSave);
					bComp = false;
					PutCompData(CompData(0, 1), achSave);
					AlignByte(achSave);
					PutCompData(CompData(nUncompBytes, 8), achSave);
					PutUncompData(nUncompBytes, nUncompStart, achFinal, achSave);
					nUncompBytes = 0;
				}
				nGetPtr++;
			}	
			else
			{
				int nMatchFinder2 = nGetPtr;
				int nMatchLength2 = 0;
				int nLongestMatch2 = 0;
				int nLongestAddr2 = 0;
				while (nGetPtr + 1 - nMatchFinder2 < 768*2*2 - 1 && nMatchFinder2 >= 0)
				{
					nMatchLength2 = 0;
					while (achFinal[nGetPtr + 1 + nMatchLength2] == achFinal[nMatchFinder2 + nMatchLength2] && nGetPtr + 1 + nMatchLength2 < nFiles*768*2 && nMatchLength2 < 257)
						nMatchLength2++;
					if (nMatchLength2 > nLongestMatch2)
					{
						nLongestMatch2 = nMatchLength2;
						nLongestAddr2 = nMatchFinder2;
					}
					nMatchFinder2--;
				}

				if (nLongestMatch2 > nLongestMatch)
				{
					if (!nUncompBytes)
						nUncompStart = nGetPtr;
					nUncompBytes++;
					if (nUncompBytes >= 255)
					{
						if (bComp)
							PutCompData(HuffmanTranslate(256), achSave);
						bComp = false;
						PutCompData(CompData(0, 1), achSave);
						AlignByte(achSave);
						PutCompData(CompData(nUncompBytes, 8), achSave);
						PutUncompData(nUncompBytes, nUncompStart, achFinal, achSave);
						nUncompBytes = 0;
					}
					nGetPtr++;
					nLongestMatch = nLongestMatch2;
					nLongestAddr = nLongestAddr2;
				}


				if (nUncompBytes)
				{
					if (nUncompBytes <= 4)
					{
						if (!bComp)
							PutCompData(CompData(1, 1), achSave);
						bComp = true;
						for (int iii = 0; iii < nUncompBytes; iii++)
						{
							PutCompData(HuffmanTranslate(achFinal[nUncompStart]), achSave);
							nUncompStart++;
						}
					}
					else
					{
						if (bComp)
							PutCompData(HuffmanTranslate(256), achSave);
						bComp = false;
						PutCompData(CompData(0, 1), achSave);
						AlignByte(achSave);
						PutCompData(CompData(nUncompBytes, 8), achSave);
						PutUncompData(nUncompBytes, nUncompStart, achFinal, achSave);
					}
				}
				nUncompBytes = 0;
				if (!bComp)
					PutCompData(CompData(1, 1), achSave);
				bComp = true;
				PutCompData(HuffmanLength(nLongestMatch), achSave);
				PutCompData(HuffmanDistance(nGetPtr-nLongestAddr), achSave);
				nGetPtr+= nLongestMatch;
			}
	//		if (!(nGetPtr%100))
	//			cout << nGetPtr << " " << endl;
		}
		if (bComp)
			PutCompData(HuffmanTranslate(256), achSave);
		AlignByte(achSave);
	} 

	delete[] achFinal;
					

	cout << 100-nPutPtr*100/(768*2*nFiles) << "% compression" << endl;

	fstream newFile(achFinalPath, ios::trunc | ios::in | ios::out | ios::binary);
	if (!newFile)
	{
		cout << "Open error on new file!" << endl;
		delete[] achSave;
		exit(1);
	}
	newFile.write((char *)achPlayCode, nPlayCodeSize);
	newFile.put(nFiles%256);
	newFile.put(nFiles/256);
	int nOnCalc = 0x82 + nPlayCodeSize;
	int nPages = 1;
	for (int iii = 0; iii < nPutPtr; iii++, nOnCalc++)
	{
		if (nOnCalc == 0x4000)
		{
			newFile.put(00);
			nOnCalc = 1;
			nPages++;
		}
		newFile.put(achSave[iii]);
	}
	newFile.close();

	delete[] achSave;


	cout << "Pages: " << nPages << endl;

//	while (1==1)
	//	Sleep(1);



		

}

